      SUBROUTINE ALONGX(Q1,Q2,RM,IERR)
C
C THIS SUBROUTINE RETURNS THE ROTATION MATRIX NEEDED TO ROTATE
C THE XY-PROJECTION OF THE BISECTOR OF THE TWO 3-VECTORS (Q1 AND
C Q2) ALONG THE X AXIS.  IERR=-1 MEANS THAT THE TWO VEC
C
CEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION Q1(3),Q2(3),RM(9)
      DATA ONEM  /-1.0/
      DATA ONE   / 1.0/
      DATA ZILCH / 0.0/
      DATA TOL  /1.D-10/
C
      IERR=0
C
C CALCULATE DIFFERENCE VECTOR
C
      CALL VADD(RM,Q1,Q2,3,ONEM) 
      TMP=RM(1)
      RM(1)=RM(2)
      RM(2)=-TMP
      RM(3)=ZILCH
      X=SNRM2(3,RM,1)
      IF(X.LT.TOL)THEN
       IERR=-1
       RETURN
      ELSE
       IERR=0
       FACT=ONE/X
       CALL SSCAL(3,FACT,RM,1)
      ENDIF
C
      ANGLE=SIGN(DACOSX(RM(1),1.D-10),RM(2))
      CALL ROTM(3,ANGLE,0,RM)
C
      RETURN
      END
